<?php

	/* Variables Globales */
	$errnum;
	/* indica posibles errores en la numeracion:
					1:no hay periodo habilitado,
				 	2:nro fuera de limites      
				 	3:nro manual ya utilizado 
				 	4:nro manual fuera de secuencia 
				 	5:nro manual no correlativo 
				 	6:error en la grabacion de la automat*/
	$forma;
	/* indica forma de numeracion :
					1:automatica,
					2:manual					*/
	
	$g_nro=0;
	/* Bufferes de tablas */
	$buffer_gral_codnum;
	$buffer_gral_automat;
	$buffer_gral_manual;

	/**
	* Obtiene un codigo de numeracion para movimiento segun una forma manual o automatica.
	* @param dbclass $p_manejadordb Objeto manejador de la base de datos
	* @param integer $p_empresa Codigo de empresa
	* @param integer $p_sucursal Codigo de sucursal
	* @param integer $p_codrel Codigo de relacion numerica
	* @param string  $p_fecha Fecha del comprobante dd/mm/aaaa
	* @param integer $p_grabo Indica si debo actualizar la numeracion (1:si,0:no)
	* @param integer $p_vez indica si es la primera o segunda vez que llamo a la 
					rutina en el programa (para saber si ya accedi al re-
					gistro y esta lockeado)
	* @return integer Retorna el codigo de numeracion.
	*/
	function Rutnum($p_manejadordb, $p_empresa, $p_sucursal, $p_codrel, $p_fecha, $p_grabo, $p_vez)
	{
		//echo "<strong>Rutnum</strong><br/>";
		global $buffer_gral_codnum;
		global $g_nro;
		global $forma;
		
		
		
		$buffer_gral_codnum = $p_manejadordb->Leo_CodNum($p_empresa, $p_sucursal, $p_codrel);
		
		if($buffer_gral_codnum[0]['formanu'] == 'A')
		{
			
			$forma=1;
			if($p_grabo != 3 && $p_grabo != 4)
			{
				return sraut($p_manejadordb, $p_empresa, $p_sucursal, $p_codrel, $p_fecha, $p_grabo, $p_vez);
			}

		}
		else
			$forma=2;
		
		
	}

	/** Numeracion Automatica de Comprobantes  
	* @param dbclass $p_manejadordb Objeto manejador de la base de datos
	* @param integer $p_empresa Codigo de empresa
	* @param integer $p_sucursal Codigo de sucursal
	* @param integer $p_codrel Codigo de relacion numerica
	* @param string $p_fecha Fecha del comprobante dd/mm/aaaa
	* @param integer $p_grabo Indica si debo actualizar la numeracion 
	*													1: si,
	*													0: no,
	*													2: borro porque ignoraron
	*													3: borro porque anularon
	*													4: marco porque modificaron
	* @param integer $p_vez indica si es la primera o segunda vez que llamo a la 
					rutina en el programa (para saber si ya accedi al re-
					gistro y esta lockeado)
	* @param integer $p_nro numero de comprobante (cuando no es solicitud de numero)
	* @return integer Retorna el codigo de numeracion automatica.
	**/
	function sraut( $p_manejadordb, $p_empresa, $p_sucursal, $p_codrel, $p_fecha, $p_grabo, $p_vez, $p_nro )
	{
		//echo "<strong>Sraut</strong><br/>";
		
		global $g_nro;
		global $forma;
		global $errnum;
		global $buffer_gral_codnum;
		global $buffer_gral_automat;
		$g_nro = $p_nro;
		
		// Split de la fecha 
		$pattern = '/\//';
		$v_fecha= preg_split($pattern, trim($p_fecha), -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
		$v_dia = $v_fecha[0];
		$v_mes = $v_fecha[1];
		$v_anio= $v_fecha[2];
		
		$errnum=0;
		
		if($p_vez == 1)
		{
			$buffer_gral_automat[0]['empresa']=$p_empresa;
			$buffer_gral_automat[0]['sucursa']=$p_sucursal;
			$buffer_gral_automat[0]['codrel']=$p_codrel;
			$buffer_gral_automat[0]['dia']=$v_dia;
			$buffer_gral_automat[0]['mes']=$v_mes;
			$buffer_gral_automat[0]['anio']=$v_anio;
			
			if($buffer_gral_codnum[0]['periren'] == 'M')
				$buffer_gral_automat[0]['dia']=0;
				
			if($buffer_gral_codnum[0]['periren'] == 'A')
			{
				$buffer_gral_automat[0]['dia']=0;
				$buffer_gral_automat[0]['mes']=0;
			}
			
			if($buffer_gral_codnum[0]['periren'] == 'T')
			{
				$buffer_gral_automat[0]['dia']=0;
				$buffer_gral_automat[0]['mes']=0;
				$buffer_gral_automat[0]['anio']=0;
			}
			
			$buffer_gral_automat=$p_manejadordb->Leo_Automat($buffer_gral_automat[0]['empresa'], 
															 $buffer_gral_automat[0]['sucursa'], 
															 $buffer_gral_automat[0]['codrel'], 
															 $buffer_gral_automat[0]['anio'], 
															 $buffer_gral_automat[0]['mes'], 
															 $buffer_gral_automat[0]['dia']);
															 
			
			if(!$buffer_gral_automat)
			{
				$errnum=1;
				return 0;
			}
			
			
			//echo 'Nro de la LeoAutomat: '.$buffer_gral_automat[0]['nro']. "<br/>";

			// Rutina para numeros salteados 
			
			$v_nousado=null;
			//Cambia la fecha de parametro dd/mm/aaa a aaaa-mm-dd
			$p_filt_fecha=$v_anio . "-" . $v_mes . "-" . $v_dia;
			/*
			//GetRecord inverso de la manual
			trigger_error("----------Antes de buscar manual-----------------", E_USER_NOTICE);
			$buffer_gral_manual = $p_manejadordb->Busca_Manual($p_empresa, $p_sucursal, $p_codrel, $buffer_gral_automat[0]['anio'], $buffer_gral_automat[0]['mes'], $buffer_gral_automat[0]['nro']);
			//echo "Busca_Manual($p_empresa, $p_sucursal, $p_codrel, " . $buffer_gral_automat[0]['anio'] . ", " .$buffer_gral_automat[0]['mes']. ", " .$buffer_gral_automat[0]['nro'] . ");<br />";
			trigger_error("----------Despues de buscar manual-----------------", E_USER_NOTICE);
			$cant_busca=count($buffer_gral_manual);
			$v_i=0;
			$v_i=$cant_busca;
			//while($v_i<$cant_busca)
			while($v_i>0)
			{
				if( $buffer_gral_manual[$v_i]['fecha'] != $p_filt_fecha )
					break;
				
				if( $buffer_gral_manual[$v_i]['uso'] == 2 )
				{
					$v_nousado = $buffer_gral_manual[$v_i]['nro'];
					$buffer_gral_automat[0]['nro'] = $v_nousado;
					break;
				}
				
				//$v_i++;
				$v_i--;
			}
			*/
			if( $v_nousado == null )
				$buffer_gral_automat[0]['nro'] = $buffer_gral_automat[0]['nro']+1;
			
			//echo "<br/><strong>buffer_gral_automat_nro:" . $buffer_gral_automat[0]['nro'] . "</strong><br />";

			if( $buffer_gral_automat[0]['nro'] < $buffer_gral_codnum[0]['nroinic'] ||
				$buffer_gral_automat[0]['nro'] > $buffer_gral_codnum[0]['nrotope'] )
			{
				$errnum=2;
				return 0;
			}
			
			
			
			if( $v_nousado == null )
			{
				$buffer_gral_automat[0]['fecha'] =  $p_filt_fecha;
				//echo "Actualizando automat<br />";
				$v_sql="UPDATE general.automat SET nro=" . $buffer_gral_automat[0]['nro'] .
				", fecha='". $buffer_gral_automat[0]['fecha'] . "' WHERE empresa=" . $p_empresa.' AND sucursa='.$p_sucursal.
		' AND codrel='.$p_codrel.' AND anio='.$buffer_gral_automat[0]['anio'].' AND mes='.$buffer_gral_automat[0]['mes'].' AND dia='.$buffer_gral_automat[0]['dia'].';';
				//echo $v_sql . "<br />";
				
				
				
				$p_manejadordb->obtenerdatos($v_sql);
				
				if($p_manejadordb->procesoCorrecto  == false)
					$errnum=6;
				
			}
			
			$v_NumGra=Graboman($p_manejadordb, 1,0, $v_nousado);
			
			if( $v_NumGra < 0 )
				return -1;
			
			if( $v_nousado == null )
				return $buffer_gral_automat[0]['nro'];
			else
				return $v_nousado;
				
		}
		
		// Si no vino por primera vez
		
		$buffer_gral_automat[0]['empresa']=$p_empresa;
		$buffer_gral_automat[0]['sucursa']=$p_sucursal;
		$buffer_gral_automat[0]['codrel']=$p_codrel;
		$buffer_gral_automat[0]['dia']=$v_dia;
		$buffer_gral_automat[0]['mes']=$v_mes;
		$buffer_gral_automat[0]['anio']=$v_anio;
		
		
		if($buffer_gral_codnum[0]['periren'] == 'M')
			$buffer_gral_automat[0]['dia']=0;
			
		if($buffer_gral_codnum[0]['periren'] == 'A')
		{
			$buffer_gral_automat[0]['dia']=0;
			$buffer_gral_automat[0]['mes']=0;
		}
		
		if($buffer_gral_codnum[0]['periren'] == 'T')
		{
			$buffer_gral_automat[0]['dia']=0;
			$buffer_gral_automat[0]['mes']=0;
			$buffer_gral_automat[0]['anio']=0;
		}
		
		$buffer_gral_automat=$p_manejadordb->Leo_Automat($buffer_gral_automat[0]['empresa'],
 														$buffer_gral_automat[0]['sucursal'], 
														$buffer_gral_automat[0]['codrel'], 
														$buffer_gral_automat[0]['anio'], 
														$buffer_gral_automat[0]['mes'], 
														$buffer_gral_automat[0]['dia']);
		
		
		if($p_grabo ==	2)
		{
			if($buffer_gral_automat[0]['nro'] == $p_nro)
			{
				$buffer_gral_automat[0]['nro']=$buffer_gral_automat[0]['nro']-1;
				//SetLFld(gral|AUTOMAT_NRO, LFld(gral|AUTOMAT_NRO)-1);
				
				//echo "Actualizando automat<br />";
				$v_sql="UPDATE general.automat SET nro=" . $buffer_gral_automat[0]['nro'] .
				", fecha='". $buffer_gral_automat[0]['fecha'] . "' WHERE empresa=" . $p_empresa.' AND sucursa='.$p_sucursal.
		' AND codrel='.$p_codrel.' AND anio='.$buffer_gral_automat[0]['anio'].' AND mes='.$buffer_gral_automat[0]['mes'].' AND dia='.$buffer_gral_automat[0]['dia'].';';
				//echo $v_sql . "<br />";
				
				//PutRecord(gral|AUTOMAT);
				Graboman($p_manejadordb, 2,1);
			}
			else
			{
				$buffer_gral_automat[0]['nro']=$p_nro;
				//SetLFld(gral|AUTOMAT_NRO, $p_nro);
				Graboman($p_manejadordb, 2,0);
			}
		}
		if($p_grabo == 3)
		{
			$buffer_gral_automat[0]['nro']=$p_nro;
			//SetLFld(gral|AUTOMAT_NRO, $p_nro);
			Graboman($p_manejadordb, 3,0);
		}
		if($p_grabo == 4)
		{
			$buffer_gral_automat[0]['nro']=$p_nro;
			//SetLFld(gral|AUTOMAT_NRO, $p_nro);
			Graboman($p_manejadordb, 4,0);
		}
		
	}


	 /** Funcion que genera la numeracion manual
	* @param dbclass $p_manejadordb Objeto manejador de la base de datos
	* @param integer $p_empresa Codigo de empresa
	* @param integer $p_sucursal Codigo de sucursal
	* @param integer $p_codrel Codigo de relacion numerica
	* @param string  $p_fecha Fecha del comprobante dd/mm/aaaa
	* @param integer $p_nro Numero ingresado
	* @param integer $p_tipo Tipo de comprobante                                      
	* @param integer $p_subt Subtipo de comprobante                                   
	* @param integer $p_grabo Indica si debo actualizar la numeracion 
	*													1: si, 
	*													0: no, 
	*													2: borro por ignore 
	*													3: borro por delete 
	*													4: marcar por modificacion 
	* @return integer Retorna el codigo de numeracion automatica.
	 **/
	function srman( $p_manejadordb, $p_empresa, $p_sucursal, $p_codrel, $p_fecha,
					$p_nro, $p_tipo, $p_subt, $p_grabo )
	{
		
		
		global $g_nro;
		global $forma;
		global $errnum;
		global $buffer_gral_codnum;
		global $buffer_gral_automat;
		global $buffer_gral_manual;
		//var $v_dia, $v_mes, $v_anio;
		$g_nro=$p_nro;
		
		// Split de la fecha (DToDMY)
		$pattern = '/\//';
		$v_fecha= preg_split($pattern, trim($p_fecha), -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
		$v_dia = $v_fecha[0];
		$v_mes = $v_fecha[1];
		$v_anio= $v_fecha[2];
		$errnum=0;
		
		$buffer_gral_manual[0]['empresa']=$p_empresa;
		$buffer_gral_manual[0]['sucursa']=$p_sucursal;
		$buffer_gral_manual[0]['codrel']=$p_codrel;
		$buffer_gral_manual[0]['nro']=$p_nro;
		
//		$buffer_gral_manual[0]['mes']=$v_mes;
//		$buffer_gral_manual[0]['anio']=$v_anio;
		$buffer_gral_manual[0]['mes']=0;
		$buffer_gral_manual[0]['anio']=0;

		
		if($buffer_gral_codnum[0]['periren'] == 'A')
		{
			$buffer_gral_manual[0]['mes']=0;
			$v_mes=0;
		}
		if($buffer_gral_codnum[0]['periren'] == 'T')
		{
			$buffer_gral_manual[0]['mes']=0;
			$buffer_gral_manual[0]['anio']=0;
			$v_mes=0;
			$v_anio=0;
		}
		
		
		if($p_grabo == 2)
		{
			$buffer_gral_manual=$p_manejadordb->Leo_Manual( $buffer_gral_manual[0]['empresa'], 
															$buffer_gral_manual[0]['sucursa'], 
															$buffer_gral_manual[0]['codrel'], 
															$buffer_gral_manual[0]['anio'], 
															$buffer_gral_manual[0]['mes'], 
															$buffer_gral_manual[0]['nro'] );
			if(!$buffer_gral_manual)
				echo "RUTNUM:SRMAN:CUIDADO:No se pudo borrar el n&uacute;mero";
			else
			{
				$v_sql="DELETE FROM general.manual " .
				" WHERE empresa=" . $buffer_gral_manual[0]['empresa'] . " AND sucursa=" . $buffer_gral_manual[0]['sucursa'] .
				" AND codrel=" . $buffer_gral_manual[0]['codrel'] . " AND anio=" . $buffer_gral_manual[0]['anio'] . 
				" AND mes=" . $buffer_gral_manual[0]['mes'] . 
				" AND nro=" . $buffer_gral_manual[0]['nro'] . ";";
			}
			return;
		}
		if($p_grabo == 3)
		{
			$buffer_gral_manual=$p_manejadordb->Leo_Manual( $buffer_gral_manual[0]['empresa'], 
															$buffer_gral_manual[0]['sucursa'], 
															$buffer_gral_manual[0]['codrel'], 
															$buffer_gral_manual[0]['anio'], 
															$buffer_gral_manual[0]['mes'], 
															$buffer_gral_manual[0]['nro'] );
			if(!$buffer_gral_manual)
				echo "RUTNUM:SRMAN:CUIDADO:No se pudo marcar la anulaci&oacute;n";
			else
			{
				$buffer_gral_manual[0]['uso'] = 1;
				$v_sql="UPDATE general.manual SET fecha='" . $buffer_gral_automat[0]['fecha'] . 
				"', uso=" . $buffer_gral_manual[0]['uso'] . 
				", tipo=null, subt=0 " . /* CABLEADO A NULL Y A 0 ? */
				" WHERE empresa=" . $buffer_gral_manual[0]['empresa'] . " AND sucursa=" . $buffer_gral_manual[0]['sucursa'] .
				" AND codrel=" . $buffer_gral_manual[0]['codrel'] . " AND anio=" . $buffer_gral_manual[0]['anio'] . 
				" AND mes=" . $buffer_gral_manual[0]['mes'] . 
				" AND nro=" . $buffer_gral_manual[0]['nro'] . ";";
			}
			return;
		}
		if($p_grabo == 4)
		{
			$buffer_gral_manual=$p_manejadordb->Leo_Manual( $buffer_gral_manual[0]['empresa'], 
															$buffer_gral_manual[0]['sucursa'], 
															$buffer_gral_manual[0]['codrel'], 
															$buffer_gral_manual[0]['anio'], 
															$buffer_gral_manual[0]['mes'], 
															$buffer_gral_manual[0]['nro'] );
			if(!$buffer_gral_manual)
				echo "RUTNUM:SRMAN:CUIDADO:No se pudo marcar la anulaci&oacute;n";
			else
			{
				$buffer_gral_manual[0]['uso'] = 3;
				$v_sql="UPDATE general.manual SET fecha='" . $buffer_gral_automat[0]['fecha'] . 
				"', uso=" . $buffer_gral_manual[0]['uso'] . 
				", tipo=null, subt=0 " . /* CABLEADO A NULL Y A 0 ? */
				" WHERE empresa=" . $buffer_gral_manual[0]['empresa'] . " AND sucursa=" . $buffer_gral_manual[0]['sucursa'] .
				" AND codrel=" . $buffer_gral_manual[0]['codrel'] . " AND anio=" . $buffer_gral_manual[0]['anio'] . 
				" AND mes=" . $buffer_gral_manual[0]['mes'] . 
				" AND nro=" . $buffer_gral_manual[0]['nro'] . ";";
			}
			return;
		}
		
		//La normal
		$buffer_anterior=$buffer_gral_manual;
/*		trigger_error("Leyendo la manual con:" . $buffer_gral_manual[0]['empresa']. " - ".
														$buffer_gral_manual[0]['sucursa']. " - ".
														$buffer_gral_manual[0]['codrel']. " - ".
														$buffer_gral_manual[0]['anio']. " - ".
														$buffer_gral_manual[0]['mes']. " - " .
														$buffer_gral_manual[0]['nro']
														, E_USER_NOTICE);*/
		$buffer_gral_manual=$p_manejadordb->Leo_Manual( $buffer_gral_manual[0]['empresa'], 
														$buffer_gral_manual[0]['sucursa'], 
														$buffer_gral_manual[0]['codrel'], 
														$buffer_gral_manual[0]['anio'], 
														$buffer_gral_manual[0]['mes'], 
														$buffer_gral_manual[0]['nro'] );
		if( utl_count($buffer_gral_manual) )
		{
			$errnum=3;
			return;
		}
		else
		{
			$buffer_gral_manual=$buffer_anterior;
		}

		//GetRecord inverso de la manual
		$buffer_anterior=$buffer_gral_manual;
		$buffer_gral_manual = $p_manejadordb->Busca_Manual_Inverso(	$buffer_gral_manual[0]['empresa'], 
																	$buffer_gral_manual[0]['sucursa'], 
																	$buffer_gral_manual[0]['codrel'], 
																	$buffer_gral_manual[0]['anio'], 
																	$buffer_gral_manual[0]['mes'], 
																	$buffer_gral_manual[0]['nro'] );
		
		if($buffer_gral_manual)
		{
			// Verifica secuencia si hay tal control 
			if($buffer_gral_codnum[0]['ctrlsec'] == 1)
				if( $buffer_gral_manual[0]['empresa'] == $p_empresa  &&
					$buffer_gral_manual[0]['sucursa'] == $p_sucursal &&
					$buffer_gral_manual[0]['codrel']  == $p_codrel   &&
					$buffer_gral_manual[0]['anio']    == $v_anio     &&
					$buffer_gral_manual[0]['mes']     == $v_mes      &&
					$buffer_gral_manual[0]['fecha'] > $p_fecha )
				{
					//FreeTable(gral|MANUAL);
					$errnum=4;
					return;
				}
			// Verifica correlatividad si hay tal control 
			if($buffer_gral_codnum[0]['ctrlcor'] == 1)
				if( $buffer_gral_manual[0]['empresa'] == $p_empresa  &&
					$buffer_gral_manual[0]['sucursa'] == $p_sucursal &&
					$buffer_gral_manual[0]['codrel']  == $p_codrel   &&
					$buffer_gral_manual[0]['anio']    == $v_anio     &&
					$buffer_gral_manual[0]['mes']     == $v_mes      &&
					$buffer_gral_manual[0]['nro'] != ($p_nro-1) )
				{
					//FreeTable(gral|MANUAL);
					$errnum=5;
					return;
				}
		}
		else
		{
			$buffer_gral_manual=$buffer_anterior;
		}

		if($p_grabo == 1)
		{
			$buffer_gral_manual[0]['empresa']=$p_empresa;
			$buffer_gral_manual[0]['sucursa']=$p_sucursal;
			$buffer_gral_manual[0]['nro']=$p_nro;
			$buffer_gral_manual[0]['fecha']=$p_fecha;
			$buffer_gral_manual[0]['tipo']=$p_tipo;
			$buffer_gral_manual[0]['subt']=$p_subt;
			$buffer_gral_manual[0]['uso']=0;

			$v_sql="INSERT INTO general.manual 
				(empresa, sucursa, codrel, anio, mes, nro, fecha, tipo, subt, uso) VALUES (" . 
				$buffer_gral_manual[0]['empresa'] . ", " .
				$buffer_gral_manual[0]['sucursa'] . ", " .
				$buffer_gral_manual[0]['codrel'] . ", " .
				"0" . ", " .
				"0" . ", " .
				$buffer_gral_manual[0]['nro'] . ", '" .
				$buffer_gral_manual[0]['fecha'] . "', " .
				"null, 0, " .
				$buffer_gral_manual[0]['uso'] . ");";
			//echo $v_sql . "<br />";

			$p_manejadordb->obtenerdatos($v_sql);

		}
	
	}
	
	/** Actualiza la numeracion en la tabla manual
	* @param dbclass $p_manejadordb Objeto manejador de la base de datos
	* @param integer $p_forma Indica forma de numeracion
	*				1:automatica,
	*				2:manual
	* @param string  $p_borro Indica si borra la numeracion
	*/
	function Graboman($p_manejadordb, $p_forma, $p_borro, $p_nousado)
	{
		//echo "<strong>Graboman</strong><br/>";
		global $g_nro;
		global $buffer_gral_automat;
		global $buffer_gral_manual;
		
		// Grabo en tabla de manuales cuando es automatica
		
		$buffer_gral_manual[0]['empresa'] = $buffer_gral_automat[0]['empresa'];
		$buffer_gral_manual[0]['sucursa'] = $buffer_gral_automat[0]['sucursa'];
		$buffer_gral_manual[0]['codrel'] = $buffer_gral_automat[0]['codrel'];
		$buffer_gral_manual[0]['nro'] = $buffer_gral_automat[0]['nro'];
		$buffer_gral_manual[0]['mes'] = $buffer_gral_automat[0]['mes'];
		$buffer_gral_manual[0]['anio'] = $buffer_gral_automat[0]['anio'];
		
		//Graba uno nuevo, viene por automatico
		if($p_forma == 1)
		{
			
			$buffer_gral_manual[0]['fecha'] = $buffer_gral_automat[0]['fecha'];
			$buffer_gral_manual[0]['uso'] = 0;
			
			//echo "Insertando manual<br />";
			if(!$p_nousado)
			{
				$v_sql="INSERT INTO general.manual 
					(empresa, sucursa, codrel, anio, mes, nro, fecha, tipo, subt, uso) VALUES (" . 
					$buffer_gral_manual[0]['empresa'] . ", " .
					$buffer_gral_manual[0]['sucursa'] . ", " .
					$buffer_gral_manual[0]['codrel'] . ", " .
					$buffer_gral_manual[0]['anio'] . ", " .
					$buffer_gral_manual[0]['mes'] . ", " .
					$buffer_gral_manual[0]['nro'] . ", '" .
					$buffer_gral_automat[0]['fecha'] . "', " .
					"null, 0, " .
					$buffer_gral_manual[0]['uso'] . ");";
//				echo $v_sql . "<br />";
			}
			else
			{
				$v_sql="UPDATE general.manual SET fecha='" . $buffer_gral_manual[0]['fecha'] . 
				"', uso=" . $buffer_gral_manual[0]['uso'] . 
				", tipo=null, subt=0 " . /* CABLEADO A NULL Y A 0 ? */
				" WHERE empresa=" . $buffer_gral_manual[0]['empresa'] . " AND sucursa=" . $buffer_gral_manual[0]['sucursa'] .
				" AND codrel=" . $buffer_gral_manual[0]['codrel'] . " AND anio=" . $buffer_gral_manual[0]['anio'] . 
				" AND mes=" . $buffer_gral_manual[0]['mes'] . 
				" AND nro=" . $buffer_gral_manual[0]['nro'] . ";";
				//echo $v_sql . "<br />";
			}
			
			$p_manejadordb->obtenerdatos($v_sql);
			if( $p_manejadordb->ManejaBD->procesoCorrecto == false )
			{
				echo "Error: No pudo actualizar numeraci&oacute;n (Rutnum) <br/>";
				echo "Query sin ejecutar ".$v_sql."<br />";
				return -1;
			}
		}
		//Modifica uno ya existente
		if($p_forma == 2)
		{
			if($p_borro == 1)
			{	// DELETE
				$buffer_gral_manual[0]['nro']=$g_nro;
				//SetLFld(gral|MANUAL_NRO, g_nro);
				$buffer_anterior=$buffer_gral_manual;
				$buffer_gral_manual=$p_manejadordb->Leo_Manual( $buffer_gral_manual[0]['empresa'], 
																$buffer_gral_manual[0]['sucursa'], 
																$buffer_gral_manual[0]['codrel'], 
																$buffer_gral_manual[0]['anio'], 
																$buffer_gral_manual[0]['mes'], 
																$buffer_gral_manual[0]['nro'] );
				if(!$buffer_gral_manual)
				{
					echo "RUTNUM:GRABOMAN:CUIDADO:No se pudo borrar el numero";
					$buffer_gral_manual=$buffer_anterior;
				}
				else
				{
					$v_sql="DELETE FROM general.manual " .
					" WHERE empresa=" . $buffer_gral_manual[0]['empresa'] . " AND sucursa=" . $buffer_gral_manual[0]['sucursa'] .
					" AND codrel=" . $buffer_gral_manual[0]['codrel'] . " AND anio=" . $buffer_gral_manual[0]['anio'] . 
					" AND mes=" . $buffer_gral_manual[0]['mes'] . 
					" AND nro=" . $buffer_gral_manual[0]['nro'] . ";";
					//echo $v_sql . "<br />";
					//$p_manejadordb->obtenerdatos($v_sql);
				}
				
				
			}
			else
			{	// UPDATE
				$buffer_gral_manual[0]['nro']=$g_nro;
				//SetLFld(gral|MANUAL_NRO, g_nro);
				$buffer_anterior=$buffer_gral_manual;
				$buffer_gral_manual=$p_manejadordb->Leo_Manual( $buffer_gral_manual[0]['empresa'], 
																$buffer_gral_manual[0]['sucursa'], 
																$buffer_gral_manual[0]['codrel'], 
																$buffer_gral_manual[0]['anio'], 
																$buffer_gral_manual[0]['mes'], 
																$buffer_gral_manual[0]['nro'] );
				//if( GetRecord(gral|MANUAL, THIS_KEY, IO_LOCK|IO_TEST) == ERROR )
				if(!$buffer_gral_manual)
				{
					echo "RUTNUM:GRABOMAN:CUIDADO:No se pudo marcar el salteo";
					$buffer_gral_manual=$buffer_anterior;
				}
				else
				{
					$buffer_gral_manual[0]['uso']=2;
					//SetIFld(gral|MANUAL_USO, 2);
					//echo "Actualizando manual<br />";
					$v_sql="UPDATE general.manual SET fecha='" . $buffer_gral_manual[0]['fecha'] . 
					"', uso=" . $buffer_gral_manual[0]['uso'] . 
					", tipo=null, subt=0 " . /* CABLEADO A NULL Y A 0 ? */
					" WHERE empresa=" . $buffer_gral_manual[0]['empresa'] . " AND sucursa=" . $buffer_gral_manual[0]['sucursa'] .
					" AND codrel=" . $buffer_gral_manual[0]['codrel'] . " AND anio=" . $buffer_gral_manual[0]['anio'] . 
					" AND mes=" . $buffer_gral_manual[0]['mes'] . 
					" AND nro=" . $buffer_gral_manual[0]['nro'] . ";";
					//echo $v_sql . "<br />";
					$p_manejadordb->obtenerdatos($v_sql);
					
				}
				
				
			}
		}
		
		if($p_forma == 3)
		{
			$buffer_gral_manual[0]['fecha']=$buffer_gral_automat[0]['fecha'];
			//SetDFld(gral|MANUAL_FECHA, DFld(gral|AUTOMAT_FECHA));
			$buffer_anterior=$buffer_gral_manual;
			$buffer_gral_manual=$p_manejadordb->Leo_Manual( $buffer_gral_manual[0]['empresa'], 
															$buffer_gral_manual[0]['sucursa'], 
															$buffer_gral_manual[0]['codrel'], 
															$buffer_gral_manual[0]['anio'], 
															$buffer_gral_manual[0]['mes'], 
															$buffer_gral_manual[0]['nro'] );
			if(!$buffer_gral_manual)
			{
				echo "RUTNUM:GRABOMAN:CUIDADO:No se pudo marcar la anulacion";
				$buffer_gral_manual=$buffer_anterior;
			}
			else
			{	//UPDATE
				$buffer_gral_manual[0]['uso']=1;
				//SetIFld(gral|MANUAL_USO, 1);
				//echo "Actualizando manual<br />";
					$v_sql="UPDATE general.manual SET fecha='" . $buffer_gral_manual[0]['fecha'] . 
					"', uso=" . $buffer_gral_manual[0]['uso'] . 
					", tipo=null, subt=0 " . /* CABLEADO A NULL Y A 0 ? */
					" WHERE empresa=" . $buffer_gral_manual[0]['empresa'] . " AND sucursa=" . $buffer_gral_manual[0]['sucursa'] .
					" AND codrel=" . $buffer_gral_manual[0]['codrel'] . " AND anio=" . $buffer_gral_manual[0]['anio'] . 
					" AND mes=" . $buffer_gral_manual[0]['mes'] . 
					" AND nro=" . $buffer_gral_manual[0]['nro'] . ";";
					//echo $v_sql . "<br />";
					$p_manejadordb->obtenerdatos($v_sql);
				//PutRecord(gral|MANUAL);
			}
		}
		
		if($p_forma == 4)
		{
			$buffer_gral_manual[0]['fecha']=$buffer_gral_automat[0]['fecha'];
			//SetDFld(gral|MANUAL_FECHA, DFld(gral|AUTOMAT_FECHA));
			$buffer_anterior=$buffer_gral_manual;
			$buffer_gral_manual=$p_manejadordb->Leo_Manual( $buffer_gral_manual[0]['empresa'], 
															$buffer_gral_manual[0]['sucursa'], 
															$buffer_gral_manual[0]['codrel'], 
															$buffer_gral_manual[0]['anio'], 
															$buffer_gral_manual[0]['mes'], 
															$buffer_gral_manual[0]['nro'] );
			
			if(!$buffer_gral_manual)
			{
				echo "RUTNUM:GRABOMAN:CUIDADO:No se pudo marcar la anulacion";
				$buffer_gral_manual=$buffer_anterior;
			}
			else
			{	//UPDATE
				$buffer_gral_manual[0]['uso']=3;
				//SetIFld(gral|MANUAL_USO, 1);
				//echo "Actualizando manual<br />";
					$v_sql="UPDATE general.manual SET fecha='" . $buffer_gral_manual[0]['fecha'] . 
					"', uso=" . $buffer_gral_manual[0]['uso'] . 
					", tipo=null, subt=0 " . /* CABLEADO A NULL Y A 0 ? */
					" WHERE empresa=" . $buffer_gral_manual[0]['empresa'] . " AND sucursa=" . $buffer_gral_manual[0]['sucursa'] .
					" AND codrel=" . $buffer_gral_manual[0]['codrel'] . " AND anio=" . $buffer_gral_manual[0]['anio'] . 
					" AND mes=" . $buffer_gral_manual[0]['mes'] . 
					" AND nro=" . $buffer_gral_manual[0]['nro'] . ";";
					//echo $v_sql . "<br />";
					$p_manejadordb->obtenerdatos($v_sql);
				//PutRecord(gral|MANUAL);
			}
		}
		
	}
	
?>